'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

function _classCallCheck(instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
}

function _defineProperties(target, props) {
  for (var i = 0; i < props.length; i++) {
    var descriptor = props[i];
    descriptor.enumerable = descriptor.enumerable || false;
    descriptor.configurable = true;
    if ("value" in descriptor) descriptor.writable = true;
    Object.defineProperty(target, descriptor.key, descriptor);
  }
}

function _createClass(Constructor, protoProps, staticProps) {
  if (protoProps) _defineProperties(Constructor.prototype, protoProps);
  if (staticProps) _defineProperties(Constructor, staticProps);
  return Constructor;
}

function _defineProperty(obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
}

function syntaxHighlight(json) {
  var indent = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 4;
  var js = typeof json === "string" ? json : JSON.stringify(json, null, indent);
  js = js.replace(/&/g, '&amp;').replace(/</g, '&lt;').replace(/>/g, '&gt;');
  return "<pre>" + js.replace(/("(\\u[a-zA-Z0-9]{4}|\\[^u]|[^\\"])*"(\s*:)?|\b(true|false|null)\b|-?\d+(?:\.\d*)?(?:[eE][+\-]?\d+)?)/g, function (match) {
    var cls = 'number';
    if (/^"/.test(match)) {
      if (/:$/.test(match)) {
        cls = 'key';
      } else {
        cls = 'string';
      }
    } else if (/true|false/.test(match)) {
      cls = 'boolean';
    } else if (/null/.test(match)) {
      cls = 'null';
    }
    return '<span class="' + cls + '">' + match + '</span>';
  }) + "</pre>";
}
var JSON_EXPORT = "json";
var ToolkitSyntaxHighlighter = function () {
  function ToolkitSyntaxHighlighter(toolkit, selector) {
    var _this = this;
    var indent = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : 4;
    _classCallCheck(this, ToolkitSyntaxHighlighter);
    this.toolkit = toolkit;
    this.indent = indent;
    _defineProperty(this, "container", void 0);
    _defineProperty(this, "_suspended", false);
    this.container = typeof selector === "string" ? document.querySelector(selector) : selector;
    toolkit.bind("portRenamed", this.updateDataset.bind(this));
    toolkit.bind("dataUpdated", this.updateDataset.bind(this));
    toolkit.bind("dataLoadEnd", function () {
      setTimeout(function () {
        _this.resume();
      }, 0);
    });
    toolkit.bind("dataLoadStart", this.suspend.bind(this));
  }
  _createClass(ToolkitSyntaxHighlighter, [{
    key: "updateDataset",
    value: function updateDataset() {
      if (!this._suspended && this.container) {
        this.container.innerHTML = syntaxHighlight(this.toolkit.exportData({
          type: JSON_EXPORT
        }, this.indent));
      }
    }
  }, {
    key: "resume",
    value: function resume() {
      this._suspended = false;
      this.updateDataset();
    }
  }, {
    key: "suspend",
    value: function suspend() {
      this._suspended = true;
    }
  }]);
  return ToolkitSyntaxHighlighter;
}();

exports.ToolkitSyntaxHighlighter = ToolkitSyntaxHighlighter;
exports.syntaxHighlight = syntaxHighlight;
